/**
 * @author raimbaul
 */

import java.rmi.RemoteException;

import net.jini.core.entry.UnusableEntryException;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.RemoteEventListener;
import net.jini.core.event.UnknownEventException;
import net.jini.core.transaction.TransactionException;
import casa.JION.entry.Entry;
import casa.JION.lease.Lease;
import casa.JION.space.JavaSpace;
import casa.JION.space.JavaSpaceSingleton;

/**
 * 
 */
public class TestJION {

  /**
   * @param args
   * @throws TransactionException 
   * @throws RemoteException 
   * @throws InterruptedException 
   * @throws UnusableEntryException 
   */

  public static void main(String[] args) throws RemoteException, TransactionException, UnusableEntryException, InterruptedException {
    
    JavaSpace space= JavaSpaceSingleton.getInstance(); // The constructor JavaSpace() is not visible 
    // Instantiating an entry
    Entry entry= new Entry();
    // Add the fields you need to use
    // Here we've added two fields, board and topic
    entry.addField("board","sports"); // entry.addFileds("board","sports");
    entry.addField("topic","football"); //entry.addFileds("topic","football"); 
    // Write the entry into the space
    space.write(entry, null, Lease.FOREVER); 
    // Create a template
    Entry template=new Entry();
    // Add the fields you need to identify the kind of entry you are looking for
    // Here we've added two fields, board and topic
    entry.addField("board","sport*"); // entry.addFileds("board","sport*");
    entry.addField("topic","football|tennis|basketball"); // entry.addFileds("topic","football|tennis|basketball");
    // Read a matching entry from the space
    space.read(template, null, Long.MAX_VALUE);
    // or Take a matching entry from the space
    space.take(template, null, Long.MAX_VALUE);
    // Create a template
    Entry template2=new Entry(); // Entry template=new Entry();
    // Add the fields you need to identify the kind of entry you are interested in
    // Here we've added two fields, board and topic
    entry.addField("topic","football|tennis|basketball"); // entry.addFileds("topic","football|tennis|basketball");
    // Register a notify request
    space.notify(template2, null, new RemoteEventListener() {

      public void notify(RemoteEvent arg0) throws UnknownEventException, RemoteException {
        // TODO Auto-generated method stub
      }
    }, Lease.FOREVER, null); //space.notify(template, null, listener, Lease.FOREVER, null);
  }

}
